'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.makeSocketIODriver = makeSocketIODriver;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _xstream = require('xstream');

var _xstream2 = _interopRequireDefault(_xstream);

var _cycleRunLibAdapt = require('@cycle/run/lib/adapt');

function makeSocketIODriver(socket) {
    function get(eventName) {
        var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

        var _ref$multiArgs = _ref.multiArgs;
        var multiArgs = _ref$multiArgs === undefined ? false : _ref$multiArgs;

        var socketStream$ = _xstream2['default'].create({
            start: function start(listener) {
                this.eventListener = multiArgs ? function () {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                        args[_key] = arguments[_key];
                    }

                    return listener.next(args);
                } : function (arg) {
                    return listener.next(arg);
                };

                socket.on(eventName, this.eventListener);
            },
            stop: function stop() {
                socket.removeListener(eventName, this.eventListener);
            },
            eventListener: null
        });

        return (0, _cycleRunLibAdapt.adapt)(socketStream$);
    }

    function publish(messageType, message) {
        socket.emit(messageType, message);
    }

    return function socketIODriver(events$) {
        events$.addListener({
            next: function next(event) {
                return publish(event.messageType, event.message);
            }
        });

        return {
            get: get,
            dispose: socket.destroy.bind(socket)
        };
    };
}